' ------------------------------------------------
' Groma - MicroStation DDE Comms Test 
' ------------------------------------------------

Sub main
    bTestCalcGraph = 0
    bTestProtocol = 0
    bTestDatabase = 0
    bTestExecute = 0
    bTestMouseCapture = 1

' ------------------------------------------------
'   DDE Initialization ...
' ------------------------------------------------
    iChannel = DDEInitiate( "Groma", "Keyin" )

' ------------------------------------------------
'   CalcGraph Commands
' ------------------------------------------------
    if (bTestCalcGraph) then
        DDEExecute iChannel, "CALCGRAPH BEGINPAINT"
        DDEExecute iChannel, "CALCGRAPH POINT 120 1044000.00 750200.00 BLACK SOLID"
        DDEExecute iChannel, "CALCGRAPH POINT 121 1044020.00 750210.00 BLACK SOLID"
        DDEExecute iChannel, "CALCGRAPH LINE 1044000.00 750200.00 1044020.00 750210.00 RED DOT"
        DDEExecute iChannel, "CALCGRAPH ENDPAINT"
    end if

' ------------------------------------------------
'   Protocol commands
' ------------------------------------------------
    if (bTestProtocol) then
        DDEExecute iChannel, "PROTOCOL NEWTASK " + Chr$( 34 ) + "Test DDE Komunikace" + Chr$( 34 )
        DDEExecute iChannel, "PROTOCOL ADD " + Chr$( 34 ) + "Text protokolu" + Chr$( 34 )
        DDEExecute iChannel, "SHOW TASKPROTOCOL"
       end if

' ------------------------------------------------
'   Database Searching Commands
' ------------------------------------------------
    if (bTestDatabase) then
        PointNumber$ = "99"
        data$ = DDERequest$( iChannel, PointNumber$ )
'        if data$ = "" then data$ = "Bod nenalezen"
'        print len(data$)
'        print data$ + "|"
        Key = MbeMessageBox( "Souadnice bodu " + PointNumber$ + " :" + Chr$( 10 ) + data$, MBE_OKBox )
    end if

' ------------------------------------------------
'   Execute Commands   
' ------------------------------------------------
    if (bTestExecute) then
        DDEExecute iChannel, "OPEN FILE c:\groma\demodata\geodim\janov.crd"
    end if
    
' ------------------------------------------------
'   Mouse Capture      
' ------------------------------------------------
    if (bTestMouseCapture) then
        DDEExecute iChannel, "MOUSEDATA X=1044000.00 Y=750000.00"
    end if
    
' ------------------------------------------------
'   DDE Termination            
' ------------------------------------------------
'    DDETerminate iChannel

End Sub
